import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type {
  ClinicPrescriptionItem,
  ClinicPrescriptionItemParam
} from './model';

/**
 * 分页查询处方明细表

 */
export async function pageClinicPrescriptionItem(
  params: ClinicPrescriptionItemParam
) {
  const res = await request.get<ApiResult<PageResult<ClinicPrescriptionItem>>>(
    '/clinic/clinic-prescription-item/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询处方明细表
列表
 */
export async function listClinicPrescriptionItem(
  params?: ClinicPrescriptionItemParam
) {
  const res = await request.get<ApiResult<ClinicPrescriptionItem[]>>(
    '/clinic/clinic-prescription-item',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加处方明细表

 */
export async function addClinicPrescriptionItem(data: ClinicPrescriptionItem) {
  const res = await request.post<ApiResult<unknown>>(
    '/clinic/clinic-prescription-item',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改处方明细表

 */
export async function updateClinicPrescriptionItem(
  data: ClinicPrescriptionItem
) {
  const res = await request.put<ApiResult<unknown>>(
    '/clinic/clinic-prescription-item',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除处方明细表

 */
export async function removeClinicPrescriptionItem(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    '/clinic/clinic-prescription-item/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除处方明细表

 */
export async function removeBatchClinicPrescriptionItem(
  data: (number | undefined)[]
) {
  const res = await request.delete<ApiResult<unknown>>(
    '/clinic/clinic-prescription-item/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询处方明细表

 */
export async function getClinicPrescriptionItem(id: number) {
  const res = await request.get<ApiResult<ClinicPrescriptionItem>>(
    '/clinic/clinic-prescription-item/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
